#ifndef VULKANCPPSETUP_VULKANRENDERER_H
#define VULKANCPPSETUP_VULKANRENDERER_H

#include "ShaderLoader.h"
#include <QVulkanWindowRenderer>
#include <qvulkanfunctions.h>

class VulkanRenderer : public QVulkanWindowRenderer {
public:
  explicit VulkanRenderer(QVulkanWindow *w);

  void initResources() override;
  void releaseResources() override;

  void startNextFrame() override;

private:
  QVulkanWindow *m_window;
  QVulkanDeviceFunctions *m_devFuncs{};
  unsigned long m_frameNumber{0UL};
  ShaderLoader m_shaderLoader{};
  VkPipelineLayout m_pipelineLayout{};
  VkPipeline m_graphicsPipeline{};
};

#endif // VULKANCPPSETUP_VULKANRENDERER_H
